using Ai.AgentServer.Server;
using Ai.AgentServer.Server.Fuel;
using Ai.AgentServer.Server.Mqtt_Ext;
using Microsoft.AspNetCore.Mvc;
using MQTTnet.Client;
using Newtonsoft.Json;

namespace Ai.AgentServer.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class FCCController : ControllerBase
    {
        private static readonly string[] Summaries = new[]
        {
            "Freezing", "Bracing", "Chilly", "Cool", "Mild", "Warm", "Balmy", "Hot", "Sweltering", "Scorching"
        };

        private readonly ILogger<FCCController> _logger;

        private readonly IHttpServer _server;

        private readonly IMqttServer _mqttServer;

        private readonly MqttClientConfig mqttClientConfig;

        public FCCController(ILogger<FCCController> logger, IHttpServer httpServer, IMqttServer mqttServer,IConfiguration configuration)
        {
            _logger = logger;
            _server = httpServer;
            _mqttServer = mqttServer;
            mqttClientConfig= configuration.GetSection("MqttSettings").Get<MqttClientConfig>();
        }

        /// <summary>
        /// ͻ
        /// </summary>
        /// <returns></returns>
        [HttpPost(Name = "FuelCommon")]
        public async Task<FuelReponse> SendCommon(FuelSendRequest body)
        {
            if (string.IsNullOrWhiteSpace(body.Type))
            {
                return new FuelReponse(5001, "TypeΪ", body);
            }
            _logger.LogInformation($"ͻ{SendCommon}:{JsonConvert.SerializeObject(body)}");
            FuelReponse reponse = null;
            //if (test)
            //{
            //    reponse = _server.GetFackData(body);
            //}
            //else {
          
            //}
            //Ѷɵ
            reponse = await _server.SendCommon(body);

            ////
            //reponse.MQTT_Public=await _mqttServer.PublicMessage(body.GLId,body.Type, body.BuildDto(2));

            reponse.DataJson = body.BuildDto();
            return reponse;
        }

        /// <summary>
        /// ͻ
        /// </summary>
        /// <returns></returns>
        [HttpGet(Name = "Init")]
        public Task Init()
        {
            var client = new MqttClientService();
            client.MqttClientStart(mqttClientConfig);
            return Task.CompletedTask;
        }





        /// <summary>
        /// mqtt test public
        /// </summary>
        /// <param name="message"></param>
        /// <param name="topic"></param>
        /// <param name="key"></param>
        /// <returns></returns>
        [HttpPost("testMqttpub")]
        public Task<string> MqttPublic(string message, string topic, string key)
        {
            if (string.IsNullOrEmpty(key) || key != "tktest")
            {
                return Task.FromResult("key is error");
            }
            try
            {
                MqttClientService._mqttClient.PublishStringAsync(topic, message).Wait();
            }
            catch (Exception ex)
            {
                return Task.FromResult($"message is error : {ex.Message}"); ;
            }
            return Task.FromResult("message is success public"); ;
        }


        /// <summary>
        /// mqtt test Sub
        /// </summary>
        /// <
        /// <param name="topic"></param>
        /// <param name="key"></param>
        /// <returns></returns>
        [HttpPost("testtSub")]
        public Task<string> MqttSub(string topic, string key)
        {
            if (string.IsNullOrEmpty(key) || key != "tksubtest")
            {
                return Task.FromResult("key is error");
            }
            try
            {
                MqttClientService._mqttClient.SubscribeAsync(topic).Wait();
            }
            catch (Exception ex)
            {
                return Task.FromResult($"topic is error : {ex.Message}"); ;
            }
            return Task.FromResult("topic is success MqttSub"); ;
        }





    }
}
