using Ai.AgentServer;
using Ai.AgentServer.Server;
using Ai.AgentServer.Server.Mqtt_Ext;
using NLog.Web;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.

builder.Services.AddControllers();
// Learn more about configuring Swagger/OpenAPI at https://aka.ms/aspnetcore/swashbuckle
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen();

var config= builder.Configuration.GetSection("MqttSettings").Get<MqttClientConfig>();
builder.Services.AddHttpClient();
builder.Logging.ClearProviders();
builder.Host.UseNLog();
//MQTT
//builder.Services.AddMqttClientManager();
//new MqttClientManager(builder.Configuration);
builder.Services.AddTransient<IHttpServer,HttpServer>();
builder.Services.AddTransient<IMqttServer, MqttServer>();
var app = builder.Build();

// Configure the HTTP request pipeline.
if (app.Environment.IsDevelopment())
{
    app.UseSwagger();
    app.UseSwaggerUI();
}

app.UseHttpsRedirection();

app.UseAuthorization();

app.MapControllers();



//var mqttClientManager = builder.Services.BuildServiceProvider().GetService<IMqttClientManager>();
//var mqttClient = mqttClientManager.GetClient();
//var rt = await mqttClient.SubscribeAsync("/ToServer/34322113", (e) =>
//{
//    Console.WriteLine("sub:" + "/ToServer/34322113 =>" + e.Topic + ":" + e.Payload.ToStr());
//});
CommonMessageHandle.init(builder.Configuration.GetSection("Sysurl").Value.ToString());
//var client = new MqttClientService();
//client.MqttClientStart(config);


app.Run();
