﻿using Ai.AgentServer.Server.Fuel;
using Ai.AgentServer.Server.FuelDto;
using AutoMapper;
using Newtonsoft.Json;
using System.Net.Http.Json;
using System.Text;

namespace Ai.AgentServer.Server
{
    /// <summary>
    /// 订阅的消息处理
    /// </summary>
    public class CommonMessageHandle
    {
        public static string Sysurl;

        public static void init(string url)
        {
            Sysurl = url;
        }



        /// <summary>
        /// 处理消息
        /// </summary>
        /// <param name="topic"></param>
        /// <param name="message"></param>
        public static void Handle(string topic, string message)
        {
            try
            {
                //获取对应的设备id,加油机id
                string deviceId = topic.Split('/').LastOrDefault();
                var messageDto = JsonConvert.DeserializeObject<MqttReceveMessageDto>(message);
                Console.WriteLine($"handlie message: {message}");
                if (messageDto != null && messageDto.msgID > 0)
                {
                    switch (messageDto.msgID)
                    {
                        case 10000:
                            LockNozzle(deviceId, messageDto);
                            break;

                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }

        }

        /// <summary>
        /// 调用油机锁枪
        /// </summary>
        /// <param name="deviceId"></param>
        /// <param name="mqttMessageDto"></param>
        /// <returns></returns>
        public static bool LockNozzle(string deviceId, MqttReceveMessageDto mqttMessageDto)
        {
            using (var httpclient = new HttpClient())
            {
                httpclient.BaseAddress = new Uri(Sysurl);
                var request = new FuelCommRequest();
                request.GLid = deviceId;
                request.NozzleNo = mqttMessageDto.data.nozzleNum;
             
                try
                {
                    Console.WriteLine($"LockNozzle HttpClient: {Sysurl}");
                    var reponse = httpclient.PostAsJsonAsync<FuelCommRequest>("/aiFueling/internal/sendData", request).Result; 
                   //httpclient.PostAsync($"/aiFueling/internal/sendData", new StringContent(JsonConvert.SerializeObject(mqttMessageDto), Encoding.UTF8, "application/json")).Result;
                    if (reponse != null&& reponse.IsSuccessStatusCode)
                    {
                        Console.WriteLine($"LockNozzle send success");
                    }
                }
                catch (Exception ex)
                {
                    Console.WriteLine($"LockNozzle error:{ex.Message}");
                    return false;
                }
                return true;
            }
        }
    }
}
