﻿namespace Ai.AgentServer.Server.Fuel
{
    public class BaseFuelReponse {
        public int Code { get; set; }
        public string Message { get; set; }
        public Data Data { get; set; }
        public string Type { get; set; }
    }
    /// <summary>
    /// 响应结构
    /// </summary>
    public class FuelReponse: BaseFuelReponse
    {
     

        /// <summary>
        /// 讯飞AIID
        /// </summary>
        public string AiId { get; set; }

        /// <summary>
        /// 格灵深瞳ID
        /// </summary>
        public string GLId { get; set; }

        public bool MQTT_Public { get; set; }

        public object DataJson { get; set; }
        public FuelReponse()
        {
            
        }

        public FuelReponse(BaseFuelReponse baseFuelReponse)
        {
            Code = baseFuelReponse.Code;
            Data = baseFuelReponse.Data;
            Message = baseFuelReponse.Message;
            Type = baseFuelReponse.Type;
        }

        /// <summary>
        /// 给响应结构赋值应用id 和 命令类型
        /// </summary>
        /// <param name="request"></param>
        public FuelReponse SetID(FuelSendRequest request)
        {
            AiId = request.AIId;
            GLId = request.GLId;
            Type = request.Type;
            return this;
        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="code"></param>
        /// <param name="request"></param>
        public FuelReponse(int code, FuelSendRequest request)
        {
            AiId = request.AIId;
            GLId = request.GLId;
            Type = request.Type;
            Code = code;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="code"></param>
        /// <param name="request"></param>
        public FuelReponse(int code,string message, FuelSendRequest request)
        {
            AiId = request.AIId;
            GLId = request.GLId;
            Type = request.Type;
            Code = code;
            message = message;
        }
    }

    /// <summary>
    /// 
    /// </summary>
    public class Data
    {
        /// <summary>
        ///   //定量加油金额 如是0 标识不定量
        /// </summary>
        public string OilAmount { get; set; }

        /// <summary>
        ///  //定量加油升数，如是0 标识不定量
        /// </summary>
        public string OilLiters { get; set; }

        /// <summary>
        /// 车牌号
        /// </summary>
        public string LicensePlate { get; set; }
    }
}


