﻿using Ai.AgentServer.Server.FuelDto;

namespace Ai.AgentServer.Server.Fuel
{
    public class FuelSendRequest
    {
        /// <summary>
        /// 指令
        /// </summary>
        public string Type { get; set; }

        /// <summary>
        /// 加油机id
        /// </summary>
        public string ClientId { get; set; }

        /// <summary>
        /// Aiid
        /// </summary>
        public string AIId { get; set; }

        /// <summary>
        /// 格林id
        /// </summary>
        public string GLId { get; set; }

        /// <summary>
        /// 油枪
        /// </summary>
        public int NozzleNo { get; set; }

        /// <summary>
        /// 油品编码
        /// </summary>
        public string OilCode { get; set; }

        /// <summary>
        /// 卡余额
        /// </summary>
        public decimal Balance { get; set; }

        /// <summary>
        /// 最大的可加金额
        /// </summary>
        public decimal MaxRefuelingAmount { get; set; }

        /// <summary>
        ///  // 0 验证码加油方式或卡类型无效;   1 司机卡; //4 员工卡;// 5  验泵卡；6 维修卡    
        /// </summary>
        public int CardType { get; set; }

        /// <summary>
        /// 金额
        /// </summary>
        public decimal Amount { get; set; }

        /// <summary>
        /// 加油体积
        /// </summary>
        public decimal Vol { get; set; }

        /// <summary>
        ///  "1"   // 车牌匹配标记 "1" 匹配  "0"不匹配   "2"不是限车号卡
        /// </summary>
        public int LicensePlateMatching { get; set; }





        /// <summary>
        /// 转成讯飞的文档实体对象   or 格灵深瞳的实体对象
        /// </summary>
        /// <param name="idType">应用id 赋值，1是讯飞，</param>
        /// <returns></returns>
        public HttpThirdRequest BuildDto(int idType=1) {
            var dto= new HttpThirdRequest {
                userId = idType ==1?AIId:GLId,
                textInput=new  Textinput()
            };
            dto.textInput.type = Type;

            switch (Type) {
                case "refuel_card_refund":
                case "refuel_card_max_oilamount":
                    dto.textInput.payload = new Refuel_card_refund() { 
                        CardType = CardType,
                        OilCode = OilCode,
                        Balance=Balance,
                        MaxRefuelingAmount=MaxRefuelingAmount,
                        NozzleNo= NozzleNo
                    };
                    break;
                    //车队车牌限制的结果
                case "refuel_card_send_license_plate_match":
                   
                        dto.textInput.payload = new Refuel_card_send_license_plate_match()
                        {
                            CardType = CardType,
                            OilCode = OilCode,
                            LicensePlateMatching = LicensePlateMatching,
                            NozzleNo = NozzleNo
                        };
           
                    break;
                case "fuelSend":
                    dto.textInput.payload = new CardPayload(cardType: CardType, oilCode: OilCode, nozzleNo: NozzleNo);
                    break;
                default:
                    dto.textInput.payload = new CardPayload(cardType: CardType, oilCode: OilCode, nozzleNo: NozzleNo);
                    break;

            }
            return dto;
        }
    }
}
