﻿namespace Ai.AgentServer.Server.FuelDto
{

    /// <summary>
    /// http请求
    /// </summary>
    public class HttpThirdRequest
    {
        public string callId { get; set; } =  Guid.NewGuid().ToString();
        public int inType { get; set; } = 2;
        public Textinput textInput { get; set; }
        public string useType { get; set; } = "virtual";

        /// <summary>
        /// 通讯id
        /// </summary>
        public string userId { get; set; }
    }



    public class Textinput
    {
        public Object payload { get; set; }
        public string type { get; set; }
    }


    /// <summary>
    /// 卡片的
    /// </summary>
    public class CardPayload
    {
        /// <summary>
        ///   // 0 验证码加油方式或卡类型无效; 1 司机卡; 4 员工卡; 5 验泵卡；6 维修卡
        /// </summary>
        public int CardType { get; set; }

        /// <summary>
        ///油品信息 
        /// </summary>
        public string OilCode { get; set; }

        /// <summary>
        ///   //卡余额
        /// </summary>
        public int NozzleNo { get; set; }

        public CardPayload(int cardType, string oilCode, int nozzleNo)
        {
            CardType = cardType;
            OilCode = oilCode;
            NozzleNo = nozzleNo;
        }
        public CardPayload()
        {

        }
    }


    /// <summary>
    /// 油枪归位
    /// </summary>
    public class Refuel_out_process : CardPayload
    {
        /// <summary>
        /// 金额
        /// </summary>
        public decimal Amount { get; set; }

        /// <summary>
        /// 升数
        /// </summary>
        public decimal Vol { get; set; }
        /// <summary>
        ///   卡余额
        /// </summary>
        public decimal Balance { get; set; }
    }

    /// <summary>
    /// 卡退出
    /// </summary>
    public class Refuel_card_refund : CardPayload
    {

        /// <summary>
        ///   卡余额
        /// </summary>
        public decimal Balance { get; set; }

        /// <summary>
        ///   最大的可加金额
        /// </summary>
        public decimal MaxRefuelingAmount { get; set; }
    }

    /// <summary>
    /// 限车号卡车牌匹配结果
    /// </summary>
    public class Refuel_card_send_license_plate_match : CardPayload
    {
        /// <summary>
        /// // 车牌匹配标记 "1" 匹配  "0"不匹配   "2"不是限车号卡
        /// </summary>
        public int LicensePlateMatching { get; set; }
    }



    ///// <summary>
    ///// 一键加油授权
    ///// </summary>
    //public class OnePayload
    //{
    //    public int CardType { get; set; }
    //    public string OilCode { get; set; }
    //    public int nozzleNo { get; set; }
    //}

}
